Subject: [PATCH v1] perf: cs-etm: Fix ETMv4 CONFIGR entry in perf.data file

From: [email-masked] (Arnaldo Carvalho de Melo)
Date: Fri, 21 Jul 2017 15:37:40 -0300

Em Fri, Jul 21, 2017 at 03:35:33PM -0300, Arnaldo Carvalho de Melo escreveu:
> Em Fri, Jul 21, 2017 at 01:19:16PM -0300, Arnaldo Carvalho de Melo escreveu:
> > Em Fri, Jul 21, 2017 at 08:50:09AM -0600, Mathieu Poirier escreveu:
> > > On 12 July 2017 at 11:01, Mike Leach <[email-masked]> wrote:
> > > > The value passed into the perf.data file for the CONFIGR register in ETMv4
> > > > was incorrectly being set to the command line options/ETMv3 value.
> > > >
> > > >                 info->priv[*offset + CS_ETMV4_TRCTRACEIDR] =
> > > >                                                 coresight_get_trace_id(cpu);
> > > 
> > > I have tested this patch on my side and things work as advertised now.
> > > 
> > > Arnaldo, if you want to pick this up through your tree then:
> > > 
> > > Acked-by: Mathieu Poirier <[email-masked]>
> > > 
> > > Otherwise I'll get this, whatever you prefer.
> > 
> > I'll get it, thanks for the ping,
> 
> It is breaking the build in one of my containers, one with fedora 24 and
> a android toolchain from http://dl.google.com/android/repository/android-ndk-r12b-linux-x86_64.zip
> 
> arch/arm/util/cs-etm.c: In function 'cs_etmv4_get_config':^M
> arch/arm/util/cs-etm.c:289:24: error: 'ETM_OPT_RETSTK' undeclared (first use in this function)^M
>   if (config_opts & BIT(ETM_OPT_RETSTK))
> 
> It builds as
> 
> NDK=/opt/android-ndk-r12b/
> NDK_TOOLCHAIN=${NDK}/toolchains/arm-linux-androideabi-4.9/prebuilt/linux-x86_64/bin/arm-linux-androideabi-
> NDK_SYSROOT=${NDK}/platforms/android-24/arch-arm
> make -C /git/linux/tools/perf O=/tmp/build/perf WERROR=0 CFLAGS=${CFLAGS} ARCH=arm CROSS_COMPILE=${NDK_TOOLCHAIN} EXTRA_CFLAGS="-pie --sysroot=${NDK_SYSROOT}" 
> Ideas?

Ok, it also fails on:

  14 debian:experimental-x-arm64: FAIL

Same problem:

  CC       /tmp/build/perf/arch/arm64/util/../../arm/util/cs-etm.o
  CC       /tmp/build/perf/util/config.o
arch/arm64/util/../../arm/util/cs-etm.c: In function 'cs_etmv4_get_config':
arch/arm64/util/../../arm/util/cs-etm.c:289:24: error: 'ETM_OPT_RETSTK' undeclared (first use in this function)
  if (config_opts & BIT(ETM_OPT_RETSTK))
                        ^
arch/arm64/util/../../arm/util/cs-etm.c:270:25: note: in definition of macro 'BIT'
 #define BIT(N) (1UL << (N))
                         ^
arch/arm64/util/../../arm/util/cs-etm.c:289:24: note: each undeclared identifier is reported only once for each function it appears in
  if (config_opts & BIT(ETM_OPT_RETSTK))
                        ^
arch/arm64/util/../../arm/util/cs-etm.c:270:25: note: in definition of macro 'BIT'
 #define BIT(N) (1UL << (N))
                         ^
mv: cannot stat '/tmp/build/perf/arch/arm64/util/../../arm/util/.cs-etm.o.tmp': No such file or directory
/git/linux/tools/build/Makefile.build:101: recipe for target '/tmp/build/perf/arch/arm64/util/../../arm/util/cs-etm.o' failed
make[6]: *** [/tmp/build/perf/arch/arm64/util/../../arm/util/cs-etm.o] Error 1
/git/linux/tools/build/Makefile.build:144: recipe for target 'util' failed
make[5]: *** [util] Error 2
/git/linux/tools/build/Makefile.build:144: recipe for target 'arm64' failed
make[4]: *** [arm64] Error 2
/git/linux/tools/build/Makefile.build:144: recipe for target 'arch' failed
make[3]: *** [arch] Error 2
make[3]: *** Waiting for unfinished jobs....
  CC       /tmp/build/perf/util/ctype.o

Builds with:

ARCH=arm64
TARGET=aarch64-linux-gnu
make ARCH=${ARCH} CROSS_COMPILE=${TARGET}- -C /git/linux/tools/perf O=/tmp/build/perf

- Arnaldo